import csv

from structures.measurement import CurrentMeasurement

class Database:
  lastMeas = [None] * 16

  def __init__(self) -> None:
      self.file = open("current.csv", "a", newline='')
      self.writer = csv.writer(self.file, delimiter=' ')

  def write(self, values: list):
    meas: CurrentMeasurement
    for i, meas in enumerate(values):
      prev : CurrentMeasurement = self.lastMeas[meas.channel]
      if prev == None:
        self.writer.writerow([meas.timestamp, meas.source, meas.channel, meas.current])
        meas.saved = True
      elif prev.current != meas.current:
        if not prev.saved:
          self.writer.writerow([prev.timestamp, prev.source, prev.channel, prev.current])
        self.writer.writerow([meas.timestamp, meas.source, meas.channel, meas.current])
        meas.saved = True

      self.lastMeas[meas.channel] = meas